#include <grwin.h>
#include <stdio.h> /* for DEBUG */
#include <stdlib.h>
#include "brot.h"
#include "grad.h"
#include "mandelcommon.h"

int brotMakeBitmap(int *brot){
  int *destBrot;
  int ret;

  if((destBrot = calloc(PIXEL_X * PIXEL_X,sizeof(int))) == NULL){
    return -1;
  }
  brotMakeBitmapBuffer(destBrot,brot);
  if((ret = GWmakebmp(0,PIXEL_X,PIXEL_X,24,destBrot)) == 0){
    ret = -1;
  }

  free(destBrot);
  return ret;
}

void brotMakeBitmapBuffer(int *brotDest,int *brotSrc){
  int i,max;
  int *grad;

  grad = gradGetGrad();
  max = PIXEL_X * PIXEL_X;
  for(i = 0;i < max;i++){
    *brotDest = GWkrgb((grad[*brotSrc] >> 16) & 255,(grad[*brotSrc] >> 8) & 255,grad[*brotSrc] & 255);
    brotSrc++;
    brotDest++;
  }
  return;
}

void brotMakeBitmapBufferFor1Line(int *brotDest,int *brotSrc){
  int i;
  int *grad;
  
  grad = gradGetGrad();
  for(i = 0;i < PIXEL_X;i++){
    *brotDest = GWkrgb((grad[*brotSrc] >> 020) & 0xff,(grad[*brotSrc] >> 010) & 0xff,grad[*brotSrc] & 0xff);
    brotSrc++;
    brotDest++;
  }

  return;
}


void brotPoke(mandel *mandel,int threadId,int tskLine,int set,int bmp){
  int i,j;
  int drawLine = mandel->pReport[threadId].haveDone - mandel->pReport[threadId].lastLineDraw;
  int pixelLine[PIXEL_X];
  int *grad;
  int *brotLocal = mandel->brot[set];
  int *brotLocal_ini = mandel->brot[set];
  int offsetBrot = threadId * PIXEL_X * tskLine + PIXEL_X * mandel->pReport[threadId].lastLineDraw;
  
  brotLocal += offsetBrot;

  grad = gradGetGrad();
  
  for(i = 0;i < drawLine;i++){
    for(j = 0;j < PIXEL_X;j++){
      //printf("offset = %p\n",brotLocal - brotLocal_ini);
      pixelLine[j] = GWkrgb((grad[*brotLocal] >> 16) & 255,(grad[*brotLocal] >> 8) & 255,grad[*brotLocal] & 255);
      brotLocal++;
    }
    GWpokebmp(bmp,offsetBrot,sizeof(pixelLine),0,pixelLine);
    //GWpokebmp(bmp,0,0,0,pixelLine);
    offsetBrot += PIXEL_X;
  }
  
  return;
}
