#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "complicate.h"

#define INITIAL_SEED 0x4c

static int deComp(char *fileName);
static int enComp(char *fileName);

/* Read as CW */
int complicateCtl(int message,int color){
  int ret = 0;

  switch(message){
  case ENCOMP:
    ret |= enComp(JULIA_BMP_BW_NAME);
    ret |= enComp(JULIA_BMP_BB_NAME);
    break;
    
  case DECOMP:
    if(color == 1){
      ret |= deComp(JULIA_BMP_BW_NAME2);
    }else{
      ret |= deComp(JULIA_BMP_BB_NAME2);
    }
    break;
  }
  
  return ret;
}

/*  */
static int deComp(char *fileName){
  FILE *fpSrc = NULL,*fpDest = NULL;
  char destName[64];
  int ret;
  unsigned int seed = INITIAL_SEED,nextSeed;
  char bmpTag[] = ".bmp";
  int i=0,iMax;

  if((fpSrc = fopen(fileName,"rb")) == NULL){
    ret = -1;
    goto ERR_decomplicate;
  }

  strcpy(destName,fileName);
  strncat(destName,bmpTag,sizeof(bmpTag));
  iMax = strlen(destName);
  while(*(destName + i) != '/' & i < iMax){
    i++;
  }
  if(i == iMax){
    ret = -8;
    goto ERR_decomplicate;
  }
  if((fpDest = fopen(destName + i + 1,"wb")) == NULL){
    ret = -2;
    goto ERR_decomplicate;
  }
  
  while((nextSeed = fgetc(fpSrc)) != EOF){
    if(fputc(seed ^ nextSeed,fpDest) == EOF){
      ret = -3;
      goto ERR_decomplicate;
    }
    seed = nextSeed;
  }
  
  ret = 0;
  
 ERR_decomplicate:
  if(fpSrc != NULL){
    fclose(fpSrc);
    fpSrc = NULL;
  }
  if(fpDest != NULL){
    fclose(fpDest);
    fpDest = NULL;
  }
  
  return ret;
}

/* ǉ */
static int enComp(char *fileName){
  FILE *fpSrc = NULL,*fpDest = NULL;
  char destName[64];
  int i,iMax;
  int ret;
  unsigned int seed = INITIAL_SEED;
  int write;
  
  if((fpSrc = fopen(fileName,"rb")) == NULL){
    ret = -1;
    goto ERR_complicateMain;
  }
  strcpy(destName,fileName);
  iMax = strlen(fileName);
  i = 0;
  while(*(destName + i) != '\0' && i < iMax){
    if(*(destName + i) == '.'){
      *(destName + i) = '\0';
      break;
    }
    i++;
  }
  if(i == iMax){
    ret = -2;
    goto ERR_complicateMain;
  }
  
  if((fpDest = fopen(destName,"wb")) == NULL){
    ret = -3;
    goto ERR_complicateMain;
  }

  while((write = fgetc(fpSrc)) != EOF){
    if(fputc(seed = seed ^ write,fpDest) == EOF){
      ret = -4;
      goto ERR_complicateMain;
    }
  }
  
  ret = 0;

 ERR_complicateMain:
  if(fpSrc != NULL){
    fclose(fpSrc);
    fpSrc = NULL;
  }
  if(fpDest != NULL){
    fclose(fpDest);
    fpDest = NULL;
  }
  
  return ret;
}
