#include <grwin.h>
#include <stdio.h>
#include <string.h>
#include "loadTga.h"
#include "progressBar.h"
#include "grad.h"
#include "complicate.h"
#include "mandelcommon.h"

static void swap(int *a,int *b);
static void drawMainRect(void);
static void drawReIm(void);
static void drawSubRect(void);
static void drawColorBarRect(void);
static void drawProgressBarRect(void);
static int initGradArray(int num);
static int showGradationNumber(int num);
static void drawSaveBmpStr(void);
/* static int allocGradArray(void); */
static int loadJuliaEq(int color);
static void drawCommand(void);

static int windowId;
static int bmpJulia;

/*************************************
 grwin̏AEBhẼI[v

 return:
 : 0
 s: -1
*************************************/
int initWindow(int isWhiteBackColor){
  int openRet;
  int background = GWC_BLACK;
  int foreground = GWC_WHITE;
  int i;
  int iw = (int)WINDOW_WIDTH,ih = (int)WINDOW_HEIGHT;
  
  if(isWhiteBackColor){
    swap(&background,&foreground);
  }
  
  /* Main Window */
  openRet = GWopenx(0,0,0,foreground,background,-1,WINDOW_NAME,strlen(WINDOW_NAME));
  if(openRet <= 0){
    fprintf(stderr,"GWopenx error\n");
    return -1;
  }else{
    windowId = openRet;
  }
#ifndef DEBUG
  GWmode(3,0);
#endif
  GWsize(-1,&iw,&ih);	/* p1sNZƁA`1sNZΉ */
  GWsize(-5,&iw,&ih);	/* qEBhẼfoCXWnƃ[hWnv */
  GWsize(-3,NULL,NULL);	/* eEBhẼTCYqEBhEɍ킹 */

  GWvport(0,0,0,0);
  GWindow(0,0,WINDOW_WIDTH,WINDOW_HEIGHT);
  GWsavevp(INITIAL_VPORT);

  GWport(DRAW_RECT_MARGIN32,DRAW_RECT_MARGIN32,DRAW_RECT_MARGIN32 + DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8 * 2,DRAW_RECT_MARGIN32 + DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8 * 2);
  GWindow(-DRAW_RECT_INNER_MARGIN8,-DRAW_RECT_INNER_MARGIN8,DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8,DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8);
  GWsavevp(MAIN_VPORT);
  
  /* 4 - Sub Rect */
  for(i = 0;i < 4;i++){
    GWselvp(INITIAL_VPORT);
    GWport(DRAW_RECT_MARGIN32 * 2 + DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8 * 2,DRAW_RECT_MARGIN32 + i * (DRAW_RECT_SUB_PIXEL + DRAW_RECT_INNER_MARGIN2 * 2),
	   DRAW_RECT_MARGIN32 * 2 + DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8 * 2 + DRAW_RECT_SUB_PIXEL + DRAW_RECT_INNER_MARGIN2 * 2,DRAW_RECT_MARGIN32 + (i + 1) * (DRAW_RECT_SUB_PIXEL + DRAW_RECT_INNER_MARGIN2 * 2));
    GWindow(-DRAW_RECT_INNER_MARGIN2,-DRAW_RECT_INNER_MARGIN2,DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN2,DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN2);
    GWsavevp(SUB_VPORT_BOTTOM + i);
  }

  /* Status Area */
  GWselvp(INITIAL_VPORT);
  GWport(DRAW_RECT_MARGIN32 * 3 + DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8 * 2 + DRAW_RECT_SUB_PIXEL + DRAW_RECT_INNER_MARGIN2 * 2,WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - (DRAW_RECT_SUB_PIXEL + DRAW_RECT_INNER_MARGIN2 * 2) * 2 + DRAW_RECT_PROGRESS_BAR_HEIGHT + STATUS_AREA_SHIFT_UP,DRAW_RECT_MARGIN32 * 3 + DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8 * 2 + DRAW_RECT_SUB_PIXEL + DRAW_RECT_INNER_MARGIN2 * 2 + DRAW_RECT_GRAD_BAR_SHIFT - DRAW_RECT_MARGIN16,WINDOW_HEIGHT - DRAW_RECT_MARGIN16);
  GWindow(0,0,STATUS_AREA_WIDTH,STATUS_AREA_HEIGHT);
#ifdef DEBUG
  GWrect(0,0,STATUS_AREA_WIDTH,STATUS_AREA_HEIGHT);
#endif
  GWsavevp(STATUS_AREA_VPORT);

  /* command Area */
  GWselvp(INITIAL_VPORT);
  GWport(
	 DRAW_RECT_MARGIN32 * 3 + DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8 * 2 + DRAW_RECT_SUB_PIXEL + DRAW_RECT_INNER_MARGIN2 * 2 + SAVE_BMP_RSHIFT,
	 DRAW_RECT_MARGIN32,
	 DRAW_RECT_MARGIN32 * 3 + DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8 * 2 + DRAW_RECT_SUB_PIXEL + DRAW_RECT_INNER_MARGIN2 * 2 + SAVE_BMP_RSHIFT + DRAW_RECT_BAR_WIDTH - SAVE_BMP_RSHIFT,
	 WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - (DRAW_RECT_SUB_PIXEL + DRAW_RECT_INNER_MARGIN2 * 2) * 2 - DRAW_RECT_MARGIN16);

  GWindow(0,0,DRAW_RECT_BAR_WIDTH - SAVE_BMP_RSHIFT,WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - (DRAW_RECT_SUB_PIXEL + DRAW_RECT_INNER_MARGIN2 * 2) * 2 - DRAW_RECT_MARGIN16 - DRAW_RECT_MARGIN32);
#ifdef DEBUG
  GWrect(0,0,DRAW_RECT_BAR_WIDTH - SAVE_BMP_RSHIFT,WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - (DRAW_RECT_SUB_PIXEL + DRAW_RECT_INNER_MARGIN2 * 2) * 2 - DRAW_RECT_MARGIN16 - DRAW_RECT_MARGIN32);
#endif
  GWsavevp(SAVE_BMP_VPORT);

  /* Color Gradation Bar */
  gradBarInit(GRADATION_PICS_NUM);

  /* Progress Bar */
  progressBarInit();
  
  /* Draw Rect */
  drawMainRect();
  drawSubRect();
  gradBarRect(GRADATION_PICS_NUM);
  progressBarRect();

  gradShowGradationNumber(GRADATION_PICS_NUM);
  if(gradInitGradArray(GRADATION_PICS_NUM) != 0){
    fprintf(stderr,"reading TGA FAILED\n");
    return -1;
  }
  gradShowGradation(GRADATION_PICS_NUM);

  progressShowStatus(PROGRESS_CALCULATING);
  gradSelectGradationNumber(0);

  if(loadJuliaEq(background == GWC_WHITE) == -1){
    fprintf(stderr,"reading eqation BMP error\n");
    return -1;
  }
  //showJuliaEq();
  drawCommand();

  return 0;
}

/************************************
 Swap
 ***********************************/
static void swap(int *a,int *b){
  int tmp;

  tmp = *a;
  *a = *b;
  *b =tmp;

  return;
}

/*************************************
 C`ɘg`
 ************************************/
static void drawMainRect(void){
  float reCenter,imCenter;

  GWselvp(MAIN_VPORT);
  GWsetogn(0,-INITGR_MAIN_RECT_OGN);
  GWrect(-DRAW_RECT_INNER_MARGIN8,-DRAW_RECT_INNER_MARGIN8,DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8,DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8);
#ifdef DEBUG
  GWrect(0,0,DRAW_RECT_PIXEL,DRAW_RECT_PIXEL);
#endif
  reCenter = DRAW_RECT_PIXEL / 2;
  GWmove2(reCenter,-DRAW_RECT_INNER_MARGIN8);
  GWline2(reCenter,0);
  imCenter = DRAW_RECT_PIXEL / 2;
  GWmove2(-DRAW_RECT_INNER_MARGIN8,imCenter);
  GWline2(0,imCenter);
  GWflush(INITGR_MAIN_RECT_OGN);

  drawReIm();

  return;
}

/*************************************
 ƏcꂼEł邱Ƃ
 ************************************/
static void drawReIm(void){
#define FONT_HEIGHT_RE_IM 24.f
#define IM_SHIFT_LEFT 6.f
#define RE_SHIFT_UP 4.f
#define FONT_NAME_RE_IM "Consolas"
  GWselvp(MAIN_VPORT);
  GWsetogn(0,-STR_RE_IM_OGN);

  GWsettxt(FONT_HEIGHT_RE_IM,0,GWO_BOTTOMLEFT,-1,-1,FONT_NAME_RE_IM,strlen(FONT_NAME_RE_IM));
  GWputtxt(DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8 * 2 - FONT_HEIGHT_RE_IM * 2,-(FONT_HEIGHT_RE_IM + DRAW_RECT_INNER_MARGIN8) + RE_SHIFT_UP,"Re",2);

  GWsettxt(FONT_HEIGHT_RE_IM,90/360.f,GWO_BOTTOMLEFT,-1,-1,FONT_NAME_RE_IM,strlen(FONT_NAME_RE_IM));
  GWputtxt(-DRAW_RECT_INNER_MARGIN8 - IM_SHIFT_LEFT,DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8 * 2 - FONT_HEIGHT_RE_IM * 2,"Im",2);

  GWflush(STR_RE_IM_OGN);
  return;
}

/*************************************
 Tu`ɘg`
 ************************************/
static void drawSubRect(void){
#ifdef DEBUG
  int i;

  for(i = 0;i < 4; i++){
    GWselvp(SUB_VPORT_BOTTOM + i);
    GWsetogn(0,-INITGR_SUB_RECT_OGN);
    GWrect(-DRAW_RECT_INNER_MARGIN2,-DRAW_RECT_INNER_MARGIN2,DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN2,DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN2);
    GWrect(0,0,DRAW_RECT_PIXEL,DRAW_RECT_PIXEL);
    GWflush(INITGR_SUB_RECT_OGN);
    }
#endif
  return;
}

#if 0 /* ÓIɊmۂ̂ŎgpȂ */	  
/************************************
 Of[V̔zm
 ***********************************/
static int allocGradArray(void){
  int i;

  for(i = 0;i < GRADATION_PICS_NUM;i++){
    if((grad[i] = malloc(sizeof(int) * GRAD_TONE_NUM)) == NULL){
      break;
    }
  }

  if(i != GRADATION_PICS_NUM){
    while(--i >= 0){
      free(grad[i]);
    }
    return -1;
  }

  return 0;
}
#endif

static void drawSaveBmpStr(void){
#define FONT_HEIGHT_BMP SAVE_BMP_HEIGHT * 0.8
#define FONT_NAME_BMP "Consolas"
  GWselvp(SAVE_BMP_VPORT);
  GWsetogn(0,-SAVE_BMP_OGN);

  GWsettxt(FONT_HEIGHT_BMP,0,GWO_BOTTOM,-1,-1,FONT_NAME_BMP,strlen(FONT_NAME_BMP));
  GWputtxt(SAVE_BMP_WIDTH / 2,42.f,"Save BMP",8);

  GWflush(SAVE_BMP_OGN);

  return;
}


/***************************
 color 1 wi
 0 wi
  0
 s -1
 ***************************/
static int loadJuliaEq(int color){
  //printf("ret ret =%d\n",complicateCtl(ENCOMP));
  if(complicateCtl(DECOMP,color) != 0){
    fprintf(stderr,"failed loading juliaEqBmp");
    return -1;
  }
  if(color == 1){
    bmpJulia = GWloadbmp(0,JULIA_BMP_BW_NAME,strlen(JULIA_BMP_BW_NAME));
    remove(JULIA_BMP_BW_NAME);
  }
  else if(color == 0){
    bmpJulia = GWloadbmp(0,JULIA_BMP_BB_NAME,strlen(JULIA_BMP_BB_NAME));
    remove(JULIA_BMP_BB_NAME);
  }
  if(bmpJulia == 0){
    return -1;
  }
  return 0;
}

int showJuliaEq(void){
  GWselvp(STATUS_AREA_VPORT);
  GWsetogn(0,-JULIAEQ_BMP_OGN);
  GWsetbmp(bmpJulia,0,0,GWY_SRCCOPY,0,GWO_BOTTOMLEFT);
  GWputbmp(bmpJulia,0,STATUS_AREA_HEIGHT - FONT_HEIGHT_STATUS * 8,1);
  GWflush(JULIAEQ_BMP_OGN);
  return 0;
}

int eraseJuliaEq(void){
  GWselvp(STATUS_AREA_VPORT);
  GWerase(JULIAEQ_BMP_OGN,1);
  return 0;
}

#define FONT_NAME_COMMAND "Consolas"
static void drawCommand(void){
  int i;
  char *commandMsg[]={"END","Save as BMP","Initialize","Redraw",};

  GWselvp(SAVE_BMP_VPORT);
  GWsetogn(0,-COMMAND_OGN);

  GWrect(0,0,DRAW_RECT_BAR_WIDTH - SAVE_BMP_RSHIFT,COMMAND_RECT_HEIGHT);
  GWsettxt(FONT_HEIGHT_STATUS,0,GWO_BOTTOM,-1,-1,FONT_NAME_COMMAND,strlen(FONT_NAME_COMMAND));
  GWputtxt((DRAW_RECT_BAR_WIDTH - SAVE_BMP_RSHIFT)/2,MARGIN_STR_COMMAND,commandMsg[0],strlen(commandMsg[0]));

  for(i=1;i<sizeof(commandMsg)/sizeof(void *);i++){
    GWrect(0,(COMMAND_RECT_HEIGHT + MARGIN_COMMAND)*i + COMMAND_END_MARGIN,DRAW_RECT_BAR_WIDTH - SAVE_BMP_RSHIFT,(COMMAND_RECT_HEIGHT + MARGIN_COMMAND)*i+COMMAND_RECT_HEIGHT + COMMAND_END_MARGIN);
    GWsettxt(FONT_HEIGHT_STATUS,0,GWO_BOTTOM,-1,-1,FONT_NAME_COMMAND,strlen(FONT_NAME_COMMAND));
    GWputtxt((DRAW_RECT_BAR_WIDTH - SAVE_BMP_RSHIFT)/2,(COMMAND_RECT_HEIGHT + MARGIN_COMMAND)*i+MARGIN_STR_COMMAND+COMMAND_END_MARGIN,commandMsg[i],strlen(commandMsg[i]));
  }
  GWflush(COMMAND_OGN);
  return;
}
