#ifndef MANDEL_HEADER
#define MANDEL_HEADER

#include "mList.h"

typedef struct _report{
  int startLine;
  int haveDone;
  int lastLineDraw;
}report,*pReport;

typedef struct _lineDrawNode{
  struct mNode *prev;
  struct mNode *next;
  int *start;
  int line;
}lineDrawNode,*pLineDrawNode;

typedef struct _stackInfo{
#ifdef USE_FLOAT128
  __float128 centerX;
  __float128 centerY;
#else
  double centerX;
  double centerY;
#endif
  unsigned long long mag;
  int color;
  double juliaA;
  double juliaB;
}oct,*pOct;

typedef struct _mandel{
#ifdef USE_FLOAT128
  __float128 initialWidth;
#else
  double initialWidth;
#endif
  mDesc taskQ;
  pReport pReport;
  int threadNum;
  int isWhiteBackColor;
  int *bmp;
  int *bmp2;
  mDesc *pList;
  lineDrawNode *pNode;
  int *pixBuff;
  int *brot[5]; /* 1main + 4sub */
  oct oct[5];
}mandel,*pMandel;

#endif
