#ifndef MANDELCOMMON_HEADER
#define MANDELCOMMON_HEADER

#include "thread.h"

typedef struct _taskNode{
  void *prev;
  void *next;
  pCalcTask pTask;
}taskNode,*pTaskNode;

#define DRAW_RECT_PIXEL 512.f
#define PIXEL_X 512
#define DRAW_RECT_SUB_PIXEL 128.f
#define DRAW_RECT_BAR_WIDTH 256.f
#define GRAD_TONE_NUM 256
#define DRAW_RECT_BAR_HEIGHT 16.f
#define DRAW_RECT_BAR_MARGIN 8.f
#define DRAW_RECT_PROGRESS_BAR_HEIGHT 32.f
#define DRAW_RECT_MARGIN32 32.f
#define DRAW_RECT_MARGIN16 16.f
#define DRAW_RECT_INNER_MARGIN8 8.f
#define DRAW_RECT_INNER_MARGIN2 2.f
#define DRAW_RECT_GRAD_BAR_SHIFT 192.f

#define MARGIN_HORIZONTAL DRAW_RECT_MARGIN32 * 4
#define MARGIN_VERTICAL DRAW_RECT_MARGIN16 + DRAW_RECT_MARGIN32
#define WINDOW_WIDTH DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8 * 2 + DRAW_RECT_SUB_PIXEL + DRAW_RECT_INNER_MARGIN2 * 2 + DRAW_RECT_BAR_WIDTH + MARGIN_HORIZONTAL
#define WINDOW_HEIGHT DRAW_RECT_PIXEL + DRAW_RECT_INNER_MARGIN8 * 2 + MARGIN_VERTICAL
#define MAIN_VPORT 1
#define SUB_VPORT_BOTTOM 2 /* ここから順に4つ使う */
#define INITIAL_VPORT 8
#define COLOR_BAR_VPORT 10 /* ここから順に最大9個使う */
#define PROGRESS_BAR_VPORT 20
#define SAVE_BMP_VPORT 24
#define STATUS_AREA_VPORT 30
#define WINDOW_NAME "mandel"
#define GRADATION_PICS_NAME "grad"
#define GRADATION_PICS_NUM 9 /* must be less than 10 */
#define DRAW_PROGRESS_BAR_WIDTH 100.f
#define DRAW_RECT_BMP_HEIGHT 24.f
#define STATUS_AREA_WIDTH 160.f
#define STATUS_AREA_HEIGHT (DRAW_RECT_SUB_PIXEL + DRAW_RECT_INNER_MARGIN2 * 2) * 2 - DRAW_RECT_PROGRESS_BAR_HEIGHT - STATUS_AREA_SHIFT_UP
#define SAVE_BMP_RSHIFT 64.f
#define SAVE_BMP_WIDTH 160.f
#define SAVE_BMP_HEIGHT 192.f
#define STATUS_AREA_SHIFT_UP 24.f
#define COMMAND_RECT_HEIGHT 20.f
#define MARGIN_COMMAND 8.f
#define MARGIN_STR_COMMAND 4.f
#define COMMAND_END_MARGIN 16.f

/* OGN */
#define PROGRESS_OGN 2000
#define GRADATION_OGN 1000
#define INITGR_MAIN_RECT_OGN 3000
#define INITGR_SUB_RECT_OGN 4000
#define PROGRESSBAR_RECT_OGN 5000
#define GRADBAR_RECT_OGN 6000
#define GRAD_NUM_OGN 7000
#define STR_RE_IM_OGN 8000
#define PROGRESSBAR_STR_OGN 9000
#define STATUS_THREAD_NUM_OGN 10000
#define STATUS_MAX_ITERATE_OGN 10001
#define STATUS_MAG_OGN 10002
#define STATUS_FLOAT128_OGN 10003
#define STATUS_CENTER_COORD 10010
#define MAG_RECT_OGN 19999
#define MAIN_BMP_OGN 20000
#define SAVE_BMP_OGN 12002
#define JULIAEQ_BMP_OGN 12003
#define MANDELBROT_STR_OGN 12004
#define JULIA_STR_OGN 12004
#define CHECK_SET_OGN 12005
#define COMMAND_OGN 12006

#define PROGRESS_CALCULATING 0
#define PROGRESS_COMPLETED 1

#define FONT_HEIGHT_STATUS 18.f

/* キーボードの入力 */

#endif
